import json
import os
import subprocess

from tenacity import retry

from helpers.constants import RETRY_CONFIG
from helpers.credentials import DE4_HOST
from helpers.ssh import DE4_KEY_FILE_NAME


@retry(**RETRY_CONFIG)
def get_service_data(service_name, service_type):
    command = ["ssh", f"dokku@{DE4_HOST}", "-p", "3022", "-i", DE4_KEY_FILE_NAME, f"{service_type}:export", service_name, ">", f"{os.getcwd()}/migration/de4/databases/{service_name}.dump"]
    result = subprocess.call(command)
    print(result)


def get_unique_services():
    f = open(f"{os.getcwd()}/migration/de4/apps_de4.json", "r")
    apps_file = f.read()
    apps = json.loads(apps_file)
    apps = list(map(lambda i: i["apps"]["apps"], apps))
    apps = sum(apps, [])
    services = list(map(lambda app: app["linkedServices"], apps))
    services = sum(services, [])
    services = list(map(lambda service: {"name": service["name"], "type": service["serviceType"]}, services))

    # TODO: Ensure that we services contains only unique items

    return services

if __name__ == "__main__":
    services = get_unique_services()
    for service in services:
        get_service_data(service["name"], service["type"])