from pathlib import Path
from tenacity import stop_after_attempt, wait_random, retry_if_not_exception_type

from .errors import DoNotRetryException

BASE_PATH = Path(__file__).resolve().parent.parent

DE4_APPS_FAILED_LOAD = f"{BASE_PATH}/migration/de4/failed_apps_de4.json"
DE4_USERS_INFO_JSON_PATH = f"{BASE_PATH}/migration/de4/users_de4.json"
DE4_APPS_INFO_JSON_PATH = f"{BASE_PATH}/migration/de4/apps_de4.json"
DE4_PORTAL_JSON_PATH = f"{BASE_PATH}/migration/de4/portal.json"
DE4_WORKSPACES_DATA_DIRECTORY = f"{BASE_PATH}/migration/de4/workspaces"

DE5_APPS_INFO_PATH = f"{BASE_PATH}/migration/de5/apps_de5.json"
DE5_USERS_PATH = f"{BASE_PATH}/migration/de5/users_de5.json"
DE5_FAILED_USERS_PATH = f"{BASE_PATH}/migration/de5/failed_users_de5.json"

DE5_GIT_ORIGIN_NAME = "de5"

DE5_APPS_PATH = f"{BASE_PATH}/migration/de5/apps"
DE4_APPS_PATH = f"{BASE_PATH}/migration/de4/apps"

DE5_APPS_SLICING = slice(0, None)
# Uncomment if we are need create and deploy only first 2 apps
# DE5_APPS_SLICING = slice(0, 2)

DEPLOY_APP_MINUTES_DELAY = 5

RETRY_CONFIG = {
    "stop": stop_after_attempt(5),
    "wait": wait_random(min=1, max=2),
    "retry": retry_if_not_exception_type(DoNotRetryException)
}

DE5_STATUS_FILE_PATH = f"{BASE_PATH}/migration/de5/status.json"
DE5_REPORT_FILE_PATH = f"{BASE_PATH}/migration/de5/report.json"
DE5_DETAILED_REPORT_FILE_PATH = f"{BASE_PATH}/migration/de5/detailed_report.csv"

OLD_PYTHON_FOLDER_SUBNAME = "-old-python"
OLD_PIP_FOLDER_SUBNAME = "-old-pip"

# Concurrent config
MAX_WORKSPACE_DEPLOYMENTS = 2
MAX_WORKSPACE_CREATION_ATTEMPTS = 5
MAX_WORKSPACE_STATUS_VALIDATION_ATTEMPTS = 30
