from dotenv import load_dotenv
import os
from .constants import BASE_PATH
from .file import is_file_exists

env_file_location = os.path.join(
    BASE_PATH,
    '.env'
)

is_env_file_exists = is_file_exists(
    env_file_location
)

if not is_env_file_exists:
    print('\033[91mOops.. the .env file is not present. '
          'You need to create the .env file to allow scripts to work properly.'
          ' Use .env.sample file as a template.\033[0m')
    exit()

load_dotenv()

DE4_ADMIN_USERNAME = os.environ.get("DE4_ADMIN_USERNAME")
DE4_ADMIN_PASSWORD = os.environ.get("DE4_ADMIN_PASSWORD")
DE4_ADMIN_TOKEN = os.environ.get("DE4_ADMIN_TOKEN")
DE4_HOST = os.environ.get("DE4_HOST")
DE4_SSH_USER = os.environ.get("DE4_SSH_USER")
DE4_SSH_PORT = os.environ.get("DE4_SSH_PORT")
DE4_SSH_PRIVATE_KEY_PATH = os.environ.get("DE4_SSH_PRIVATE_KEY_PATH")

DE5_HOST = os.environ.get("DE5_HOST")
DE5_KEYCLOAK_ADMIN_USERNAME = os.environ.get("DE5_KEYCLOAK_ADMIN_USERNAME")
DE5_KEYCLOAK_ADMIN_PASSWORD = os.environ.get("DE5_KEYCLOAK_ADMIN_PASSWORD")
DE5_INTERNAL_PYPI_SERVICE = os.environ.get("DE5_INTERNAL_PYPI_SERVICE")

if DE4_ADMIN_USERNAME is None or DE4_ADMIN_TOKEN is None:
    print("The DE4_ADMIN_USERNAME and DE4_ADMIN_TOKEN environment variables is required for the correct work")
