class DoNotRetryException(Exception):
    def __init__(self):
        super(DoNotRetryException, self).__init__("This is special error to avoid using retry mechanism. "
                                                  "Find the reason above.")


def handle_de4_api_key_error(e):
    if e.errors is not None:
        error = e.errors[0]
        if error is not None and error.get('message') == 'Bad API key':
            print("\033[91mFailed: Please, ensure that your DE4 API key is correct\033[0m")
            raise DoNotRetryException()
    raise e
