import json
import os
import shutil

import toml
import yaml


def save_to_file(file_name, data, is_json=True, binary=False):
    with open(file_name, f"w{'b' if binary else ''}") as f:
        if is_json:
            data = json.dumps(data)
        f.write(data)


def get_from_file(file_name):
    try:
        return json.loads(get_from_file_raw(file_name))
    except Exception as e:
        print(e)
        print(f"\033[91mFailed to get data from \"{file_name}\"\033[0m")
        return {}


def get_from_file_raw(file_name):
    with open(file_name, "r") as f:
        data = f.read()
        return data


def copy_directory(source, destination):
    shutil.copytree(source, destination)


def remove_file_if_exists(file_path):
    if is_file_exists(file_path):
        os.remove(file_path)


def is_file_exists(file_path):
    return os.path.exists(file_path)


def save_as_toml_file(data, path):
    with open(path, "w") as toml_file:
        toml.dump(data, toml_file)


def load_from_toml_file(path):
    return toml.load(path)


def save_as_yaml_file(data, path):
    with open(path, 'w') as yaml_file:
        yaml.dump(data, yaml_file)


def make_directory(path):
    os.mkdir(path)


def delete_file(path):
    os.remove(path)