from .client import client
from queries import GET_APP_NAMES
from gql.transport.exceptions import TransportQueryError
from .errors import handle_de4_api_key_error


def get_app_names():
    page = 0
    all_names = []
    print("[Get app names]: Started.")
    while True:
        try:
            result = client.execute(GET_APP_NAMES, variable_values={"page": page})
            app_names = map(lambda item: item["name"], result["apps"]["apps"])
            all_names.extend(app_names)
            next_page = result["apps"]["nextPage"]
            if next_page is None:
                break
            page = next_page
        except TransportQueryError as e:
            handle_de4_api_key_error(e)

    print("[Get app names]: Finished.")
    return all_names
