import requests
from keycloak import KeycloakOpenID
from requests.structures import CaseInsensitiveDict

from .credentials import DE5_HOST

keycloak_url = f"https://auth-{DE5_HOST}/auth/"
graphql_url = f"https://api-{DE5_HOST}/graphql"

headers_memo = {}

def get_headers(user):
    headers = headers_memo.get(user["username"], None)

    if headers is None:
        keycloak_openid = KeycloakOpenID(
            server_url=keycloak_url,
            client_id="dash",
            realm_name="dash"
        )

        token = keycloak_openid.token(user["username"], user["password"], ["password"], code="", redirect_uri="",
                                      totp=None, scope='openid')
        headers = CaseInsensitiveDict()
        headers["Content-type"] = "application/json"
        headers["Accept"] = "application/json"
        headers["Authorization"] = 'Bearer {}'.format(token['access_token'])

    return headers


def de5_request(request, user):
    return requests.post(graphql_url, json=request, headers=get_headers(user))
