import os
from PIL import Image
from io import BytesIO
import base64


def get_image_size(path):
    return os.path.getsize(path)


def resize_image(path, resize_value):
    image = Image.open(path)
    width, height = image.size
    width = int(width/resize_value)
    height = int(height/resize_value)
    image = image.resize((width, height))
    image.save(path)


def resize_image_to_match_max_size(path, max_size):
    image_size = get_image_size(path)

    while image_size > max_size:
        resize_image(path, 1.25)
        image_size = get_image_size(path)


def convert_image_to_base64(path):
    image = Image.open(path)
    buffered = BytesIO()
    image.save(buffered, format="PNG")
    return base64.b64encode(buffered.getvalue()).decode('utf-8')
