import json

from .constants import DE5_USERS_PATH, DE5_APPS_INFO_PATH, BASE_PATH
from .file import get_from_file


def get_de4_users():
    f = open(f"{BASE_PATH}/migration/de4/users_de4.json", "r")
    return json.loads(f.read())


def get_de5_users():
    f = open(DE5_USERS_PATH, "r")
    return json.loads(f.read())


def get_de5_user_by_username(username):
    users = get_de5_users()
    for user in users:
        if user.get("username") == username:
            return user


def get_de5_admin():
    users = get_de5_users()
    for user in users:
        if user.get("admin"):
            return user


def get_app_owners():
    apps = get_from_file(DE5_APPS_INFO_PATH)
    owner_usernames = [app.get("owner") for app in apps]
    users = get_de5_users()
    owners = [user for user in users if user.get("username") in owner_usernames]
    return owners
