import sys
from pathlib import Path
sys.path.append(Path(__file__).resolve().parent.parent.__str__())

import json

from helpers.constants import DE4_APPS_INFO_JSON_PATH
from helpers.git import clone_app


def get_app_names():
    f = open(DE4_APPS_INFO_JSON_PATH, "r")
    apps = json.loads(f.read())
    return list(map(lambda item: item["name"], apps))


if __name__ == "__main__":
    names = get_app_names()
    total_names = len(names)

    # Ask the user to choose between SSH or HTTPS cloning
    clone_option = input("Do you want to clone the app with SSH or HTTPS? Please type 'ssh' or 'https': ")
    use_https = clone_option.lower() == 'https'

    print("[App processing]: Started.")
    for index, name in enumerate(names):
        try:
            clone_app(name, use_https=use_https)
        except Exception as e:
            print(f"\033[91mToo many failed attempts for the {name} app. Skipped.\033[0m")

        print(f"[App processing]: Processed {index + 1} of {total_names} apps: \"{name}\".")

    print("[App processing]: Finished.")
