import sys
from pathlib import Path
sys.path.append(Path(__file__).resolve().parent.parent.__str__())

from helpers.ssh import attach_de5_key, generate_de5_key
from helpers.users import get_app_owners


def attach_user_key(user, key_type):
    username = user.get("username")
    key = generate_de5_key(username, key_type)
    attach_de5_key(key, user)
    print(f"\033[92mSSH key was attached for the \"{username}\" user.\033[0m")

def ask_key_type():
    print("Which key type would you like to use?")
    print("1. ed25519 (recommended)")
    print("2. RSA")

    choice = input("Please enter the number of your choice: ")

    if choice == "1" or choice == "2":
        return choice
    else:
        print("Invalid choice, please enter 1 or 2.")
        return ask_key_type()

if __name__ == "__main__":
    key_type = ask_key_type()
    users = get_app_owners()
    for user in users:
        attach_user_key(user, key_type)
