import sys
from pathlib import Path
sys.path.append(Path(__file__).resolve().parent.parent.__str__())

from helpers.apps import filter_apps_by_names
from helpers.constants import DE5_APPS_INFO_PATH, DE5_STATUS_FILE_PATH, OLD_PIP_FOLDER_SUBNAME
from helpers.deploy import deploy_apps
from helpers.file import get_from_file

apps = get_from_file(DE5_APPS_INFO_PATH)


def get_app_names():
    statuses = get_from_file(DE5_STATUS_FILE_PATH)
    result = []
    for key, value in statuses.items():
        if value is not None and value.get('status', '') == 'failed':
            result.append(key)

    return result


if __name__ == "__main__":
    app_names = get_app_names()
    apps = filter_apps_by_names(apps, app_names)
    deploy_apps(apps, OLD_PIP_FOLDER_SUBNAME)
