import shutil
import os
import sys
from pathlib import Path

sys.path.append(Path(__file__).resolve().parent.parent.__str__())
from helpers.constants import DE5_APPS_PATH, BASE_PATH, DE4_APPS_PATH, DE4_WORKSPACES_DATA_DIRECTORY

directories_to_full_to_clean = [
    DE5_APPS_PATH,
    f"{BASE_PATH}/migration/de5/ssh",
    f"{BASE_PATH}/migration/de4/ssh",
    f"{BASE_PATH}/migration/de4/databases",
    DE4_APPS_PATH,
    DE4_WORKSPACES_DATA_DIRECTORY,
]
directories_to_first_level_clean = [f"{BASE_PATH}/migration/de5/", f"{BASE_PATH}/migration/de4/"]
retain = [".gitkeep"]


def clean_directory(working_directory, remove_directory):
    os.chdir(working_directory)

    for item in os.listdir(os.getcwd()):
        if item not in retain:
            is_directory = os.path.isdir(item)
            if is_directory:
                if remove_directory:
                    shutil.rmtree(item)
            else:
                os.remove(item)


def main():
    for directory in directories_to_full_to_clean:
        clean_directory(directory, True)

    for directory in directories_to_first_level_clean:
        clean_directory(directory, False)


if __name__ == "__main__":
    main()
